/* OUTPUT ONLY VERSION
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
* <joerg@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.        Joerg Wunsch
 * $Id: uart.c,v 1.1.2.1 2005/12/28 22:35:08 joerg_wunsch Exp $
  * ----------------------------------------------------------------------------
*/


#include <stdint.h>
#include <stdio.h>

#include <avr/io.h>

#include "uart.h"

/*
 * Initialize the UART to baud rate, tx/rx, 8N1.
 */
void uart_init(int UART_BAUD)
{
  UBRR0H = 0;
  UBRR0L = (F_CPU / (16UL * UART_BAUD)) - 1;
  UCSR0B = _BV(TXEN0) | _BV(RXEN0); /* tx/rx enable */
}

/*
 * Send character c to the UART Tx, wait until tx holding register
 * is empty.
 */
int uart_putchar(char c, FILE *stream)
{
  if (c == '\n') uart_putchar('\r', stream);
  loop_until_bit_is_set(UCSR0A, UDRE0);
  UDR0 = c;

  return 0;
}

void uart_putc(char c) {
   loop_until_bit_is_set(UCSR0A, UDRE0);
  UDR0 = c;
}

void uart_puts(char *str) {
// print a string constant
    while (*str != 0) uart_putc( *str++ );
}


